﻿#region Category: Header Text

// ***********************************************************************
// Assembly         : NoFlyingInLegion\NoFlyingInLegion\NoFlyingInLegion.cs
// Author           : Weischbier
// Created          : 25 - 04 - 2017 at 11:31 PM
// 
// Last Modified By : Weischbier
// Last Modified On : 27 - 04 - 2017 at 12:43 AM
// ***********************************************************************
// Credits: Highvoltz for pointing me in the right direction.
// I've never worked with profiles in general, so this was all new territory even though it isn't much code xD
// 
// ***********************************************************************

#endregion

#region Category: Directives

using System;
using System.Windows.Media;
using Bots.BGBuddy.Helpers;
using JetBrains.Annotations;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Profiles.Quest.Order;
using Styx.Plugins;

#endregion

// ReSharper disable SuggestVarOrType_SimpleTypes
// ReSharper disable UnusedMember.Local

namespace NoFlyingInLegion
{
    public class NoFlyingInLegion : HBPlugin
    {
        private static string PluginVersion { get; } = "0.1.270417.1244";
        private static bool OnBrokenIsles { get; } = StyxWoW.Me.CurrentMap.MapId.Equals(1220);
        private static bool PathfinderPartTwo { get; } = new ProfileHelperFunctionsBase().IsAchievementCompleted(11446); // http://www.wowhead.com/achievement=11446/broken-isles-pathfinder-part-two

        /// <summary>
        ///     Raises the <see cref="E:NewProfileLoaded" /> event.
        /// </summary>
        /// <param name="args">The <see cref="BotEvents.Profile.NewProfileLoadedEventArgs" /> instance containing the event data.</param>
        private static void OnProfileLoaded([NotNull] BotEvents.Profile.NewProfileLoadedEventArgs args)
        {
            var prfl = args.NewProfile;
            if (OnBrokenIsles.Equals(false))
            {
                Logging.WriteDiagnostic(Colors.Lime, $"[NFIL] Player is not in the Broken Isles. ({StyxWoW.Me.CurrentMap.MapId} - {StyxWoW.Me.CurrentMap.Name})");
                return;
            }
            if (prfl.Equals(null))
            {
                Logging.WriteDiagnostic(Colors.Lime, "[NFIL] No Profile loaded!");
                return;
            }
            Logging.Write(Colors.CadetBlue, $"[NFIL] New Profile [{prfl.Name}] loaded.");
            if (prfl.NavType.Equals(NavType.Run))
            {
                Logger.Write(Colors.DarkSeaGreen, $"[NFIL] Profile is cool. No need to change NavType. [CurNavT {prfl.NavType}]");
                return;
            }
            //var acm = Lua.GetReturnVal<bool>("GetAchievementInfo(11446)", 3);
            Logging.Write(Colors.DarkRed, $"[NFIL] Profile supports flying. We loathes it. [CurNavT {prfl.NavType}]");
            Logging.Write(Colors.DarkRed, "[NFIL] Switching to NavType.Run.");
            prfl.NavType = NavType.Run;
        }

        #region Overrides of HBPlugin

        /// <summary>
        ///     Pulses this instance.
        /// </summary>
        public sealed override void Pulse()
        {
        }

        /// <summary>
        ///     Called when the plugin gets enabled.
        /// </summary>
        public sealed override void OnEnable()
        {
            if (PathfinderPartTwo.Equals(false))
            {
                Logging.Write(Colors.Lime, $"[NFIL] {Name} was NOT loaded. This character hasn't unlocked flying in the Broken Isles. (Pathfinder Part Two? {PathfinderPartTwo})");
                return;
            }
            BotEvents.Profile.OnNewOuterProfileLoaded += OnProfileLoaded;
            BotEvents.Profile.OnNewProfileLoaded += OnProfileLoaded;
            Logging.Write(Colors.CadetBlue, $"[NFIL] {Name} loaded.");
        }


        /// <summary>
        ///     Called when the plugin gets disabled.
        /// </summary>
        public sealed override void OnDisable()
        {
            BotEvents.Profile.OnNewOuterProfileLoaded -= OnProfileLoaded;
            BotEvents.Profile.OnNewProfileLoaded -= OnProfileLoaded;
            Logging.Write(Colors.CadetBlue, $"[NFIL] {Name} disabled.");
        }
        
        public sealed override string Name { get; } = "No Flying in Legion!";
        public sealed override string Author { get; } = "Weischbier";
        public sealed override Version Version { get; } = Version.Parse(PluginVersion);

        #endregion
    }
}